/*************************************************************************
	
*************************************************
**	Copyright (C) 2002 SENG digitale Syteme GmbH
**
**	SENG digitale Systeme GmbH
**	Im Bruckwasen 35
**	D 73037 Goeppingen
**	Germany
**	http://www.seng.de
*************************************************


	017konst.H - Low-Level-Konstanten und Typedefs

	Autor:		Peter Seng
	Stand:		2004-07-09

	nderungsbeschreibung:

**************************************************************************/

#if !defined( __017KONST_H )
#define __017KONST_H


#define PPack 0x40		// PC parallel port ACK (PPack) signal, (interrupt) input, parallel port baseaddress+1

#define PPnStrobe 0x1	// mm-bus write enable signal, parallel port baseaddress+2
#define PPnAutofd 0x2	// mm-bus read enable signal, parallel port baseaddress+2
#define PPinit 0x4		// PC parallel port INIT (PPinit) signal, output, parallel port baseaddress+2, printer not reset mask
#define PPnSlctin 0x8	// mm-bus address enable signal, parallel port baseaddress+2
#define PPirqen 0x10		// PC parallel port IRQEN (PPirqen) signal, IRQ enable bit, parallel port baseaddress+2
#define PPepp 0x40      // Flag, parallel port EPP status enabled
#define PPdir 0xA0		// PC parallel port DIR (PPdir) signal, disables data output drivers, for IBM+Toshiba T3200SX, parallel port baseaddress+2

#define irq_7 0x0F			// Interruptnummer IRQ 7 --> Vektor 0x0F
#define irq_7_mask 0x80		// Interruptnummer IRQ 7 --> Maske Bit7
#define irq_5 0x0D			// Interruptnummer IRQ 5 --> Vektor 0x0D
#define irq_5_mask 0x20		// Interruptnummer IRQ 5 --> Maske Bit5
#define lpt1 0x3BC			// Druckerschnittstelle LPT1 Basisadresse
#define lpt2 0x378			// Druckerschnittstelle LPT2 Basisadresse
#define lpt3 0x278			// Druckerschnittstelle LPT3 Basisadresse
#define adrpctimer 0x40		// PC-Timer Basisadresse
#define test1 0xAA			// testpattern, allgemein 10101010 
#define test2 0x55			// testpattern, allgemein 01010101 

#define RegCfgPP 0x00		// Register address parallel port config
#define RegCfgPP_ReProg 0x01	// ReProg
#define RegCfgPP_PS2 0x02		// PS2 mode
#define RegCfgPP_EPP 0x04		// EPP mode
#define RegCfgDev 0x01		// Register address device config
#define RegRomCtrl 0x02		// Register address ROM control
#define RegRamData 0x02		// Register address BASIC SRAM data
#define RegRomData 0x03		// Register address ROM data
#define RegRomAdr7 0x04		// Register address ROM address 7..0
#define RegRomAdr15 0x05	// Register address ROM address 15..8
#define RegRomAdr18 0x06	// Register address ROM address 18..16

#define FlashSA0 0x00000	//sector0   0x00000...0x0FFFF  64Kbyte
#define FlashSA1 0x10000	//sector1   0x10000...0x1FFFF  64Kbyte
#define FlashSA2 0x20000	//sector2   0x20000...0x2FFFF  64Kbyte
#define FlashSA3 0x30000	//sector3   0x30000...0x3FFFF  64Kbyte
#define FlashSA4 0x40000	//sector4   0x40000...0x4FFFF  64Kbyte
#define FlashSA5 0x50000	//sector5   0x50000...0x5FFFF  64Kbyte
#define FlashSA6 0x60000	//sector6   0x60000...0x6FFFF  64Kbyte
#define FlashSA7 0x70000	//sector7   0x70000...0x77FFF  32Kbyte
#define FlashSA8 0x78000	//sector8   0x78000...0x79FFF   8Kbyte
#define FlashSA9 0x7A000	//sector9   0x7A000...0x7BFFF   8Kbyte
#define FlashSA10 0x7C000	//sector10  0x7C000...0x7FFFF  16Kbyte

#define entrycode "V5cWQfS" // valid entrycode in "#init_entrycode" section of setup file "dlk51.dat"

#define FpgasetupDef "setup.bit" // Fpga configuration default file for setup
#define FpgaEmuDef "emudlc5.bit" // Fpga configuration file for external DLC5 emulation
#define FpgaIntDef "intdlc5.bit" // Fpga configuration file for internal DLC5 emulation
#define FpgaAVRDef "emuavrispdongle.bit" // Fpga configuration file for ATMEL AVR ISP dongle STK200 / STK300 emulation
#define FpgaAT89isp "emuat89ispcable.bit" // Fpga configuration file for AT89isp cable emulation
#define FpgaFlash "FLASH" // Fpga configured via Flash
#define FpgaClear "CLEAR" // Fpga not configured, cleared
#define FlashUnknown "UNKNOWN" // Flash-memory content unknown
#define FlashErased "ERASED" // Flash-memory content erased
#define BasicDef "basic52.dat" // BASIC header file, ASCII
#define BasicBin "basic52.$$$" // BASIC header file, binary


#endif  // __017KONST_H







