/*************************************************
**	Copyright (C) 2002 SENG digitale Syteme GmbH
**
**	SENG digitale Systeme GmbH
**	Im Bruckwasen 35
**	D 73037 Goeppingen
**	Germany
**	http://www.seng.de
*************************************************/


#include "bufwnd.h"
#include "dlk51.h"

/////////////////
// Main frame window for TRACEWIN contains trace buffer as child window, 
// not a view.
//

class CMainFrame : public CFrameWnd 
{
	DECLARE_DYNAMIC(CMainFrame)

	CBufWnd		m_wndBuffer;		// TRACE buffer
	CFile			m_file;				// if outputting to file
	UINT			m_nOutputWhere;	// where to output
	
	// CString		m_sLogFileName;	// Br, Name des LogFiles

	// helpers
	BOOL OpenFile(CFile& f, LPCSTR lpszPathName);	// helper
	void CloseTraceFile();

public:
	char					m_szSystemDrive[_MAX_PATH];
	char					m_szAnaIniDir[_MAX_PATH];

	int					m_iUpdateCPU; // global variable for update command
	char					m_szUpdateCPU[_MAX_PATH]; // global variable for update command
	
	void					HelpScreen();
	int					m_iIolptIdx;
	int					m_iIolptAdr;
	float					m_fRefVoltage;
	PFKTMESSAGE			m_lpfnMessage;		// Funktionptr to Message()-Funktion
	HINSTANCE			m_hDLL;
	BOOL					m_bIsOsWinNT;
	CAnainiApp			*m_pApp;
	USHORT				m_InID004;
	USHORT				m_InID007;
		
	void	WelcomeMessage();
	int	IsOsWinNT();
	void	AddMessage( LPCSTR pszText );
	void	GetIolptAdrFromIdx();
	void	SetIolptIdx();
	void	WriteLogFile();
	void	CMainFrame::OnProgStart();
	void	CMainFrame::OnProgStartTerminate();
	void	CMainFrame::OnAppExitKeepFPGA();
	void	CMainFrame::OnAppExitExit();

	CMainFrame();
	virtual ~CMainFrame();
	static const char* REGKEY;	// registry key for saved settings

protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra,
		AFX_CMDHANDLERINFO* pHandlerInfo);

// Br: OnWriteDataMsg(): Handler for userdefined messages
	//{{AFX_MSG(CMainFrame)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnClose();
	afx_msg void OnAppExit();
	afx_msg void OnAutoSetup();
	afx_msg void OnAppAbout();
	afx_msg void OnSetup();
	afx_msg void OnOutByte();
	afx_msg void OnTestProgress();
	afx_msg void OnTestCmds();
	afx_msg void OnUpdateMenue(CCmdUI* pCmdUI);
	afx_msg void OnTestInit278();
	afx_msg void OnTestInit378();
	afx_msg void OnTestInit3bc();
	afx_msg void OnTestProgeeprom();
	afx_msg void OnTestInitAuto();
	afx_msg void OnFILESaveMemory();
	afx_msg void OnFileProgramFlashAll();
	afx_msg void OnFileProgramFlashCpuFile0();
	afx_msg void OnFileProgramFlashCpuFile1();
	afx_msg void OnFileProgramFlashCpuFile2();
	afx_msg void OnFileProgramFlashCpuFile3();
	afx_msg void OnFileProgramFlashFpgaFile0();
	afx_msg void OnFileProgramFlashFpgaFile1();
	afx_msg void OnFpgaClear();
	afx_msg void OnFpgaConfigFlash();
	afx_msg void OnFpgaConfigPc();
	afx_msg void OnCommandCpuDisable();
	afx_msg void OnCpuRunfile0();
	afx_msg void OnCpuRunfile1();
	afx_msg void OnCpuRunfile2();
	afx_msg void OnCpuRunfile3();
	afx_msg void OnFILEEraseFlashFpgaFILE0();
	afx_msg void OnFILEEraseFlashFpgaFILE1();
	afx_msg void OnFILEEraseFlashCPUFILE0();
	afx_msg void OnFILEEraseFlashCPUFILE1();
	afx_msg void OnFILEEraseFlashCPUFILE2();
	afx_msg void OnFILEEraseFlashCPUFILE3();
	afx_msg void OnFILEEraseFlashAll();
	afx_msg void OnCOMMANDCOMMANDTestFpgaIo();
	afx_msg void OnCOMMANDTestElabBaseIo();
	afx_msg void OnCOMMANDCOMMANDSaveBasic();
	afx_msg void OnCommandEmuAVRispDongle();
	afx_msg void OnCOMMANDCOMMANDEmuDlc5();
	afx_msg void OnCOMMANDCOMMANDTransferRate();
	afx_msg void OnTestInitAux();
	afx_msg void OnUpdateCPU();
	afx_msg void OnUpdateFPGA();
	afx_msg void OnCommandEmuAT89ispCable();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_bHwAccessInstalled;
};
