/**********************************************************

****************************************************
**	Copyright (C) 2002-2005 SENG digitale Syteme GmbH
**
**	SENG digitale Systeme GmbH
**	Im Bruckwasen 35
**	D 73037 Goeppingen
**	Germany
**	http://www.seng.de
****************************************************

	Datei:	Mainfrm.cpp

  	Autor:	P. Seng, R. Brndle
	Datum:	2005-01-12

	017LAxxx - dlk51 - Main frame window

**********************************************************/


#include "stdafx.h"
#include <stdlib.h>	// for _splitpath()
#include <direct.h>

#include "dlk51_dll_Export.h"	// Import von exportierten DLL-Funktionen

#include "dlk51.h"
#include "mainfrm.h"
#include "winplace.h"
#include "TestDlg.h"
#include "OutInByteDlg.h"
#include "SetupDlg.h"
#include "ProgressDlg.h"
#include "017konst.h" // Low-Level-Konstanten und Typedefs


// prototypes for Callback-functions
void CALLBACK Message(LPCSTR pText);

// Globale Variable aus Modul CAnainiApp
extern CMainFrame* pMainFrame;

// Registry key for profile settings
//
const char* CMainFrame::REGKEY = "Settings";

//static UINT NEAR WMU_LOGWIN_DATA_MSG = RegisterWindowMessage(LOGWIN_DATA_MSG);

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_CLOSE()
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_COMMAND(IDM_AUTOSETUP, OnAutoSetup)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDM_SETUP, OnSetup)
	ON_COMMAND(IDM_OUTBYTE, OnOutByte)
	ON_COMMAND(IDM_TEST_PROGRESS, OnTestProgress)
	ON_COMMAND(IDM_TEST_CMDS, OnTestCmds)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_FpgaFILE0, OnUpdateMenue)
	ON_COMMAND(IDM_TEST_INIT_278, OnTestInit278)
	ON_COMMAND(IDM_TEST_INIT_378, OnTestInit378)
	ON_COMMAND(IDM_TEST_INIT_3BC, OnTestInit3bc)
	ON_COMMAND(IDM_TEST_PROGEEPROM, OnTestProgeeprom)
	ON_COMMAND(IDM_TEST_INIT_AUTO, OnTestInitAuto)
	ON_COMMAND(ID_FILE_Save_memory, OnFILESaveMemory)
	ON_COMMAND(ID_FILE_PROGRAMFLASH_ALL, OnFileProgramFlashAll)	
	ON_COMMAND(ID_FILE_PROGRAMFLASH_CPUFILE0, OnFileProgramFlashCpuFile0)
	ON_COMMAND(ID_FILE_PROGRAMFLASH_CPUFILE1, OnFileProgramFlashCpuFile1)
	ON_COMMAND(ID_FILE_PROGRAMFLASH_CPUFILE2, OnFileProgramFlashCpuFile2)
	ON_COMMAND(ID_FILE_PROGRAMFLASH_CPUFILE3, OnFileProgramFlashCpuFile3)	
	ON_COMMAND(ID_FILE_PROGRAMFLASH_FpgaFILE0, OnFileProgramFlashFpgaFile0)
	ON_COMMAND(ID_FILE_PROGRAMFLASH_FpgaFILE1, OnFileProgramFlashFpgaFile1)
	ON_COMMAND(ID_Fpga_CLEAR, OnFpgaClear)
	ON_COMMAND(ID_Fpga_CONFIG_FLASH, OnFpgaConfigFlash)
	ON_COMMAND(ID_Fpga_CONFIG_PC, OnFpgaConfigPc)
	ON_COMMAND(ID_COMMAND_CPU_DISABLE, OnCommandCpuDisable)
	ON_COMMAND(ID_CPU_RUNFILE0, OnCpuRunfile0)
	ON_COMMAND(ID_CPU_RUNFILE1, OnCpuRunfile1)
	ON_COMMAND(ID_CPU_RUNFILE2, OnCpuRunfile2)
	ON_COMMAND(ID_CPU_RUNFILE3, OnCpuRunfile3)
	ON_COMMAND(ID_FILE_EraseFlash_FpgaFILE0, OnFILEEraseFlashFpgaFILE0)
	ON_COMMAND(ID_FILE_EraseFlash_FpgaFILE1, OnFILEEraseFlashFpgaFILE1)
	ON_COMMAND(ID_FILE_EraseFlash_CPUFILE0, OnFILEEraseFlashCPUFILE0)
	ON_COMMAND(ID_FILE_EraseFlash_CPUFILE1, OnFILEEraseFlashCPUFILE1)
	ON_COMMAND(ID_FILE_EraseFlash_CPUFILE2, OnFILEEraseFlashCPUFILE2)
	ON_COMMAND(ID_FILE_EraseFlash_CPUFILE3, OnFILEEraseFlashCPUFILE3)
	ON_COMMAND(ID_FILE_EraseFlash_All, OnFILEEraseFlashAll)
	ON_COMMAND(ID_COMMAND_COMMAND_TestFpgaIo, OnCOMMANDCOMMANDTestFpgaIo)
	ON_COMMAND(ID_COMMAND_TestElabBaseIo, OnCOMMANDTestElabBaseIo)
	ON_COMMAND(ID_COMMAND_COMMAND_SaveBasic, OnCOMMANDCOMMANDSaveBasic)
	ON_COMMAND(ID_COMMAND_EmuAT89ispCable, OnCommandEmuAT89ispCable)
	ON_COMMAND(ID_COMMAND_EMULATEAVRISPDONGLE, OnCommandEmuAVRispDongle)
	ON_COMMAND(ID_COMMAND_COMMAND_EmuDlc5, OnCOMMANDCOMMANDEmuDlc5)
	ON_COMMAND(ID_COMMAND_COMMAND_TransferRate, OnCOMMANDCOMMANDTransferRate)
	ON_COMMAND(IDM_TEST_INIT_Aux, OnTestInitAux)
	ON_COMMAND(ID_UpdateCPU, OnUpdateCPU)
	ON_COMMAND(ID_UpdateFPGA, OnUpdateFPGA)
	ON_COMMAND(ID_APP_EXIT_KeepFPGA, OnAppExitKeepFPGA)
	ON_COMMAND(ID_APP_EXIT_EXIT, OnAppExitExit)
	ON_COMMAND(ID_ProgStart, OnProgStart)
	ON_COMMAND(ID_ProgStartTerminate, OnProgStartTerminate)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_FpgaFILE1, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_CPUFILE0, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_CPUFILE1, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_CPUFILE2, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_CPUFILE3, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_PROGRAMFLASH_ALL, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_Save_memory, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_FpgaFILE0, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_FpgaFILE1, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_CPUFILE0, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_CPUFILE1, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_CPUFILE2, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_CPUFILE3, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_FILE_EraseFlash_All, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_Fpga_CONFIG_PC, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_Fpga_CONFIG_FLASH, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_Fpga_CLEAR, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_CPU_RUNFILE0, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_CPU_RUNFILE1, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_CPU_RUNFILE2, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_CPU_RUNFILE3, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_CPU_DISABLE, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(IDM_TEST_CMDS, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_COMMAND_TestFpgaIo, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_TestElabBaseIo, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_COMMAND_SaveBasic, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_EmuAT89ispCable, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_EMULATEAVRISPDONGLE, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_COMMAND_EmuDlc5, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_COMMAND_TransferRate, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_UpdateCPU, OnUpdateMenue)
	ON_UPDATE_COMMAND_UI(ID_UpdateFPGA, OnUpdateMenue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CMainFrame::CMainFrame() 
{
	// Load state from profile
	/*
	m_nOutputWhere = ID_OUTPUT_TO_WINDOW;
	CString dir = AfxGetApp()->GetProfileString(REGKEY,"Directory");
	if (!dir.IsEmpty())
		_chdir(dir);
	*/

	// Init defualt values for members
	m_iIolptAdr		= 0x278;	// LPT2
	m_iIolptIdx		= 3;		// preset to autosearching
	m_fRefVoltage	= 0.0f;

	m_hDLL = 0; 
}


CMainFrame::~CMainFrame()
{
}

/////////////////
// Override to use "MfxTraceWindow" as 
// class name so applications can find us.
//
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
//	static LPCSTR className = NULL;

	if (!CFrameWnd::PreCreateWindow(cs))
		return FALSE;
/*
	if (className==NULL) 
	{
		// One-time class registration
		// The only purpose is to make the class name something meaningful
		// instead of "Afx:0x4d:27:32:hup1hup:hike!"
		//
		WNDCLASS wndcls;
		::GetClassInfo(AfxGetInstanceHandle(), cs.lpszClass, &wndcls);
		// ersetze Classname mit Log
		wndcls.lpszClassName = LOGWIN_CLASSNAME;
		wndcls.hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
		VERIFY(AfxRegisterClass(&wndcls));
		className=LOGWIN_CLASSNAME;
	}
	cs.lpszClass = className;
	if (AfxGetApp()->GetProfileInt(REGKEY, "KeepOnTop", 0))
		cs.dwExStyle |= WS_EX_TOPMOST;
*/
	return TRUE;
}

//////////////////
// Main frame created.
//
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Create buffer window
	if (!m_wndBuffer.Create(this, AFX_IDW_PANE_FIRST)) {
		TRACE("Failed to create buffer window\n");
		return -1;      // fail to create
	}


	// Show header with dlk51-Version number in the protocol
	WelcomeMessage();

	// initialize UpdateCPU global variables for update command
	m_iUpdateCPU=0; // CPU file0, default
	strcpy(m_szUpdateCPU," "); // init CPU filename

	// get Driveletter of Windows NT / 95 --> m_szSystemDrive
	char szSystemDir[_MAX_PATH];
	char szDrive[_MAX_DIR];   
	char szDir[_MAX_DIR];   
	char szFileName[_MAX_FNAME];
	char szExt[_MAX_EXT];

	GetSystemDirectory( 
		szSystemDir,	//LPTSTR lpBuffer,  // address of buffer for system directory
		_MAX_PATH );	//UINT uSize        // size of directory buffer

	_splitpath( szSystemDir, m_szSystemDrive, szDir, szFileName, szExt);


	// Get Path of dlk51.exe --> m_szAnaIniDir
	char szFullName[_MAX_PATH];
	GetModuleFileName(
		NULL,					// HMODULE hModule,    // handle to module to find filename for
		szFullName,			// LPTSTR lpFilename,  // pointer to buffer to receive module path
		_MAX_PATH );		// DWORD nSize         // size of buffer, in characters);
	_splitpath( szFullName, szDrive, szDir, szFileName, szExt );
	strcpy( m_szAnaIniDir, szDrive );
	strcat( m_szAnaIniDir, szDir ); // full path of dlk51.exe
	
	// Check OS-Version
	// ret: 1= NT4, 0=95/98, -1=anderere, zB win32s
	const int OS_NT	= 1;	
	const int OS_9598	= 0;
	
	int iOSVersion = IsOsWinNT();
	if ( iOSVersion == OS_NT )
	{
		m_bIsOsWinNT = TRUE;
		// Load NT-DLL into memory
		//m_hDLL = AfxLoadLibrary("AnaIniNTDLL.dll");
	}
	else 
	{
		if ( iOSVersion == OS_9598 )
		{
			m_bIsOsWinNT = FALSE;
			// Load Win95/98-DLL into memory
			//m_hDLL = AfxLoadLibrary("AnaIni9xDLL.dll");
		}
		else
		{
			//puts("this program is only running under WinNT version 4.0 or higher !");
			PostMessage(WM_CLOSE);
		}
	}


	// Save ptr to Message()-Funktion. 
	// --> Parameter for Init in dlk51_dll.dll
	m_lpfnMessage = &Message;

	// Save global ptr to message-function. Falls NULL bergeben wird, dann gibt die dlk51_dll.dll
	// keine Meldungen aus ( die Rckruffunktion g_pfnMessage() wird nicht ausgefhrt
	if ( ! HwaccInit_EnableDllMessages( m_lpfnMessage ) )
	{
		// HWAccess-Treiber wurde nicht geladen --> do nothing
		m_bHwAccessInstalled = FALSE;
	}
	else
		m_bHwAccessInstalled = TRUE;

	////////////////////////////////////////////////////////
	// Kommandozeile (Aufrufparameter) auswerten. 
	// Kopiere Aufrufparameter --> CStringArray	strArrCmdLineArgs
	// 0	-> 278	LPTAdr
	// 1	-> 4.586	RefVoltage
	// 2	-> ABCD		Code
	// 3	-> 1000		Schlssel1, ID004
	// 4	-> 0		Schlssel2, ID007
	
	// Get ptr to Application class
	m_pApp = (CAnainiApp *) AfxGetApp(); 

	if ( m_pApp->m_lpCmdLine[0] == '\0' )
	{
		// kein Commandline-parameter --> Reboot ausfhren
		// default Kommando
		// PostMessage( WM_COMMAND, ID_ProgStart );
	}
	else
	{
		int				argc = 0;
		CStringArray	strArrCmdLineArgs;
		char *string	= m_pApp->m_lpCmdLine;	// Sourcestring with blanks as delimiters
		int iParaCount = 0;
		char seps[]		= " ";		// Blank as Seperator 
		char *token;					// ptr to tokenstring in commandline

	
		// Establish string and get the first token: 
		token = strtok( string, seps );
		while( token != NULL )
		{
			// While there are tokens in "string" 
			//printf( " %s\n", token );
			// Save founded token to StringArray
			strArrCmdLineArgs.SetAtGrow(argc, token);

			// Inkrement Para-Counter
			argc++;
			
			// Get next token: 
			token = strtok( NULL, seps );
		}

		// 2. Aufrufparameter auswerten
		CString s = strArrCmdLineArgs[2];
		if ( argc == 5 &&										// 5 Aufrufparameter und
			  strArrCmdLineArgs[2].CompareNoCase("ABCD") == 0 ) // String identical ?
		{
			// Schlssel auswerten
			sscanf(strArrCmdLineArgs[0], "%x", &m_iIolptAdr);
			SetIolptIdx();
			sscanf(strArrCmdLineArgs[1], "%f", &m_fRefVoltage);
			sscanf(strArrCmdLineArgs[3], "%x", &m_InID004); // 4. Parameter, USHORT ID004
			sscanf(strArrCmdLineArgs[4], "%x", &m_InID007); // 5. Parameter, USHORT ID007	

			PostMessage( WM_COMMAND, IDM_SETIDCODES );
		}
	}
	if (m_bHwAccessInstalled == TRUE)
	{
		// HWaccess works, I/Os can be reached
		int iRetInterprete;
		iRetInterprete=InterpreteDlk51Dat(); // program flash memory "#init_data" section or initialize device according to setup file "dlk51.dat"
		switch (iRetInterprete)
		{
			case 0x0:
				PostMessage( WM_COMMAND, ID_ProgStart ); // default commando 
				break;
			case 0x8:
				PostMessage( WM_COMMAND, ID_ProgStartTerminate ); // show results and termiante
				break;
			case 0x10:
				PostMessage( WM_COMMAND, ID_APP_EXIT_KeepFPGA ); // close application, keep FPGA configured
				break;
			default:
				AfxMessageBox( "device not found" );
				break;
		}
	}
	else
	{
		// HWaccess does not work, I/Os can be reached, terminate program
		AfxMessageBox("FATAL ERROR: The driver for hardware access could not be installed\nINFO: Administrator privileges necessary\nPROGRAM TERMINATED", MB_ICONEXCLAMATION  | MB_OK );	
		PostMessage( WM_CLOSE ); // close application
	}
	return 0;
}


//////////////////
// If I get focus, give to buffer
//
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	m_wndBuffer.SetFocus();
}

//////////////////
// Got command message: pass to trace buffer
// Without this, m_wndBuffer doesn't get a chance to handle 
// menu commands with ON_COMMAND, etc.
//
BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra,
	AFX_CMDHANDLERINFO* pHandlerInfo)
{
	if (m_wndBuffer.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;	// handled by buffer window

	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::AddMessage(LPCSTR pszText)
{
	// Convert \n to \r\n (\n=NewLine, \r=Linefeed) for Windows brain-damaged 
	// edit control.
	// It's 1995, and I'm still writing code like this!
	//
	int len = strlen( pszText );
	const char* src = pszText;
	const char* endsrc = pszText + len;

	static char buf[1024];		// Copy von pszText, jedoch mit \r\n

	char* dst = buf;
	char* endbuf = buf + sizeof(buf) - 1;

	// Blank voranstellen
	*dst++ = ' ';

	while (src < endsrc && dst < endbuf) 
	{
		if (*src == '\n')
			*dst++ = '\r';
		*dst++ = *src++;
	}
	*dst = 0;

	// Append string to contents of trace buffer
	m_wndBuffer.SetSel(-1, -1);					// end of edit text
	m_wndBuffer.ReplaceSel(buf);					// append string..
	m_wndBuffer.SendMessage(EM_SCROLLCARET);	// ..and show caret

}


void CALLBACK Message(LPCSTR pText)
{
	pMainFrame->AddMessage(pText);
}

void CMainFrame::WelcomeMessage()
{
	AddMessage("*********************************************************\n");
	AddMessage("           dlk51 for Windows 9x/NT 4.0 based OS\n");
	AddMessage("   setup, test and control routines for dlk51/eLABbase\n");
	AddMessage("         (C) Copyright SENG digitale Systeme GmbH\n");
	AddMessage("*********************************************************\n\n");
}

int CMainFrame::IsOsWinNT()
{
	OSVERSIONINFO version;

	// must set size of structure
	version.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
        
	// get version data
   if (!GetVersionEx(&version))
		return(0);		// Fehler

	switch(version.dwPlatformId)
	{
		case VER_PLATFORM_WIN32_NT:
			// WinNT
			AddMessage("Operating system ...\t--> Windows NT 4.0 based OS\n");
			return(1);
		break;

		case VER_PLATFORM_WIN32_WINDOWS :
			if ( version.dwMinorVersion == 0 )
				AddMessage("Operating system ...\t--> Windows95\n");
			else
				AddMessage("Operating system ...\t--> Windows98\n");
			return(0);
		break;

		case VER_PLATFORM_WIN32s:
			AddMessage("Operating system ... \t--> Windows 3.1, Win32s\n");
        break;

		default:
			CString s;
			s.Format("Error unknown Win32 Version: %d\n", version.dwPlatformId);
			AddMessage(s);
    }           
	
    return (-1);		// Fehler, kein WinNT, kein Win95, kein Win98
}

void CMainFrame::OnAutoSetup() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	BOOL	bAutoSetup		= TRUE;	// auto-searching for device
	BOOL	bSetRefVoltage = FALSE;	// RefVoltage nicht verndern
	CString s;

	s = "re-boot device ?";
	if ( AfxMessageBox(s, MB_ICONQUESTION | MB_YESNO) != IDYES )
		return;
	
	// Ja: Benutzer mchte Auto-Setup durchfhren
	// call DLL-Functions Init() and AutoSetup()
	CWaitCursor w;
	BOOL	bRet=0;

	// reset Adr und RefVoltage fr mehrfachen Aufruf von AutoSetup
	m_iIolptAdr = 0;
	m_fRefVoltage = 0.0f;
			
	//bRet = FUNKTIONSAUFRUF
	if ( bRet==0 )
		SetIolptIdx();
	
}


void CMainFrame::GetIolptAdrFromIdx()
{
	// set absolut Adr from Index
	if ( m_iIolptIdx == 0 )
		m_iIolptAdr = 0x378;
	else
		if (m_iIolptIdx == 1 )
			m_iIolptAdr = 0x3BC;
		else
			if (m_iIolptIdx == 2 )
					m_iIolptAdr = 0x278;
			else
				// fehler
				m_iIolptAdr=-1;
}


void CMainFrame::SetIolptIdx()
{
	// set absolut Adr from Index
	if ( m_iIolptAdr == 0x378 )
		m_iIolptIdx = 0;
	else
		if (m_iIolptAdr == 0x3BC )
			m_iIolptIdx = 1;
		else
			if (m_iIolptAdr == 0x278 )
					m_iIolptIdx = 2;
}



void CMainFrame::OnAppAbout() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	CDialog(IDD_ABOUTBOX).DoModal();
}


void CMainFrame::OnSetup() 
{
	// ===========================================================================================
	// DEMO CODE, NOT USED
	// ===========================================================================================
	// shows how to handle dialogs


	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	BOOL	bRet;
	const int iRButtonIndexAutoSetup = 3;	
	
	// Setup-Dialog anlegen
	CSetupDlg dlg;

	// DDX: Init Dialog vars with members
	dlg.m_bRButtonRefVoltage =FALSE;
	dlg.m_iIolptIdx	= m_iIolptIdx;
	dlg.m_fRefVoltage = m_fRefVoltage;
	

	if ( IDOK == dlg.DoModal() )
	{
		CWaitCursor w;	// sanduhr anzeigen

		BOOL	bAutoSetup;
		

		// save dlg values to members
		// 1. Benutzereingabe: Index --> m_iIolptIdx, 
		//		0=0x378, 1=0x3BC, 2=0x278
		m_iIolptIdx		= dlg.m_iIolptIdx;
		
		// 2. Benutzereingabe: m_fRefVoltage
		if ( dlg.m_bRButtonRefVoltage )
			m_fRefVoltage	= dlg.m_fRefVoltage;
		else
			m_fRefVoltage = 0.0f;


		if ( dlg.m_iIolptIdx != iRButtonIndexAutoSetup )
		{
			// kein AutoSetup --> User whlt LPT1-LPT3
			bAutoSetup = FALSE;
			
			GetIolptAdrFromIdx(); 
		}
		else
		{
			// AutoSetup --> Gert suchen. 
			// ReturnParameter m_iIolptAdr und m_fRefVoltage
			bAutoSetup = TRUE;
		}


		// call exported DLL-function AutoSetup()
		bRet = AutoSetup( bAutoSetup, dlg.m_bRButtonRefVoltage, m_iIolptAdr, m_fRefVoltage );
		if ( bRet )
			SetIolptIdx();	
	}
}


void CMainFrame::WriteLogFile()
{
	// Save Protokoll to LogFile
	CStdioFile f;
	char szTempDir[_MAX_PATH];

	strcpy( szTempDir, m_szAnaIniDir); // path where Anaini.exe exists
	strcat( szTempDir, "dlk51.log" ); // add filename to path
	if ( f.Open( szTempDir,
					  CFile::modeCreate | CFile::modeWrite | CFile::typeText) ) 
	{
		char buf[256];
		int lineCount = m_wndBuffer.GetLineCount();
		for ( int line=0; line<lineCount; line++ ) 
		{
			int len = m_wndBuffer.GetLine( line, buf, sizeof(buf)-1 );
			buf[len++]='\n';
			buf[len]='\0';
			f.WriteString(buf);
		}
		f.Close();
	}
}


void CMainFrame::OnOutByte() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	COutInByteDlg dlg;
	dlg.DoModal();	
}


void CMainFrame::HelpScreen()
{
	AddMessage("\n");
	AddMessage("Cmdline help for test routines\n");
	AddMessage("---------------------------------\n\n");
	AddMessage("outbyte mm-bus                    o   <ADDRESSh><DATAh>, o 10 55\n");
	AddMessage("inbyte  mm-bus                    i   <ADDRESSh>, i 11\n");
	AddMessage("set/reset PPinit                  s   <0/1>, s 1\n");
	AddMessage("read PPack                        g\n");
	AddMessage("FPGA configuration                c   <FILENAME>, c demo.bit\n");
//	AddMessage("programm flash memory             F   <filename><start><end><FileOffset><verify><swap>, mirror.bin 0 7ffff 0 1 0\n");
	AddMessage("help                              ?\n\n");
} // HelpScreen()



void CMainFrame::OnTestProgress() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	// Dialog mit Fortschrittsanzeige. Warten bis Benutzer "Abbrechen" whlt
	CProgressDlg dlg;
	
	
	// DDX
	// --> nix
	
	dlg.Create();  // By default Create will disable the application's main window
	// For a progress dialog with a range that contains 10 steps ( (upper-lower) / step)
	// we would use a loop with ten calls to StepIt(). Note that the range or the step size
	// could be changed programmatically with SetRange or SetStep.


	BOOL bCanceledByUser = FALSE;
	char szText[40];

	// warte bis MR den Returnstatus gesendet hat, dh. bWaitForStatus=FALSE
	int i = 1;
	while ( 1 )		
	{
		// Abbruch, falls Benutzer abbrechen whlt
		if ( dlg.CheckCancelButton() )
		{
			bCanceledByUser = TRUE;
			break;								// exit loop. user has clicked "Abbrechen"-Button
		}

		sprintf( szText, "Loop %d\n", i );
		AddMessage( szText );


		Sleep(100);					// 100 msec warten

		if ( (i % 10) == 0 )
			dlg.StepIt();			// Step alle 1 sec = 10 * 100 msec


		i++;		// Inkr LoopCounter
	}
}



void CMainFrame::OnTestCmds() 
{
	// TODO: Add your command handler code here

	// CmdLine in Protokoll schreiben
	HelpScreen();	

	// Dialog mit CmdLine anzeigen
	CTestDlg	dlg;

	// DDX
	dlg.m_pMainFrame = this;

	// Modalen Dialog ausfhren
	dlg.DoModal();
}


void CMainFrame::OnTestProgeeprom() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	CFileDialog dlg(
		TRUE,						// BOOL bOpenFileDialog
		"*.bit",					// LPCTSTR lpszDefExt = NULL
		"*.bit",					// LPCTSTR lpszFileName = NULL
		OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
		"FPGA file (*.bit)|*.bit||",	// LPCTSTR lpszFilter = NULL
		GetParent() );			// CWnd* pParentWnd = NULL
	
	// Pfad von Fullpfad abspalten
	// von rechts nach links 
	//m_sPathOfDiadem = GetPathFromFullPath( m_sDiademFullPfad );
	
	//dlg.m_ofn.lpstrInitialDir = (LPSTR)(LPCTSTR)m_sPathOfDiadem;

	char szTitleOfFileOpenDlgBox[] = "Select FPGA config file";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;


	// DDX
	if ( dlg.DoModal() )
	{
		// Den im Browse-Dialog ausgewhlten FullPfad ins Editfeld bernehmen
		//m_sDiademFullPfad = dlg.GetPathName();
		//m_DiademPfadEditCtrl.SetWindowText( m_sDiademFullPfad );
	}
}


void CMainFrame::OnUpdateMenue(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	// enable/disable menue commands
	// prohibit device access if device is not initialized
	if ( IsDeviceInitialized()  ) // Is device initialized ?
		pCmdUI->Enable(TRUE); // enable menue commands
	else
		pCmdUI->Enable(FALSE); // disable menue commands
}


void CMainFrame::OnProgStart() 
{
	// TODO: Add your command handler code here
	// routine may be usefull at start of programm, PostMessage on result of MessageBox 
	CString s;

	s = "Re-config via PC ?";
	if (AfxMessageBox(s, MB_ICONQUESTION | MB_OKCANCEL ) != IDCANCEL )
		PostMessage( WM_COMMAND, ID_Fpga_CONFIG_PC );
}


void CMainFrame::OnProgStartTerminate() 
{
	// TODO: Add your command handler code here
	// routine may be usefull at start of programm, PostMessage on result of MessageBox 
	AfxMessageBox( "device ID codes programmed\n\npressing OK will terminate application" );
	PostMessage( WM_COMMAND, ID_APP_EXIT ); // close application, clear FPGA
}


void CMainFrame::OnClose() 
// exit application via closed frame window
// frame window closed
{
	// TODO: Add your command handler code here
	PostMessage( WM_COMMAND, ID_APP_EXIT ); // call ID_APP_EXIT
}


void CMainFrame::OnAppExit() 
// exit application via menu command or command call
{
	// TODO: Add your command handler code here
	DeInitDlk51(0); // de-initialize device and PC, clear FPGA
	PostMessage( WM_COMMAND, ID_APP_EXIT_EXIT ); // call ID_APP_EXIT_EXIT
}


void CMainFrame::OnAppExitKeepFPGA() 
// exit application via command call
{
	// TODO: Add your command handler code here
	AfxMessageBox( "device prepared for internal programming via JTAG\n\nrun iMPACT now !\n\npressing OK will terminate application" );
	DeInitDlk51(2); // de-initialize device and PC, keep FPGA initialized
	PostMessage( WM_COMMAND, ID_APP_EXIT_EXIT ); // call ID_APP_EXIT_EXIT
}


void CMainFrame::OnAppExitExit() 
// exit application 
{
	// frame window closed, save position and size in profile, save current settings in registry
	CWindowPlacement wp;
	wp.Save(REGKEY, this);

	WriteLogFile(); // write log file
	HwaccDeInit(); // Die Funktion de-initialisiert HWAccess, den Zugriff auf I/O Adressen

	// weiterleiten an basisklasse
	CFrameWnd::OnClose(); 
}


void CMainFrame::OnTestInitAuto() 
{
	// TODO: Add your command handler code here
	int iOK;

	AddMessage("\n");	// separate command output by line feed
	iOK = SetupDlk51(0x0); // generates initial values and setup file "dlk51.dat", autosearch
	if ( iOK != 0 )	// File or parallel port not found or device error
	{
		AfxMessageBox( "Device not found at 3BCh, 378h, 278h" );
		return;
	}
}


void CMainFrame::OnTestInit3bc() 
{
	// TODO: Add your command handler code here
	int iOK;
	
	AddMessage("\n");	// separate command output by line feed
	iOK = SetupDlk51(0x3BC); // generates initial values and setup file "dlk51.dat", search at port 3BCh
	if ( iOK != 0 )	// File or parallel port not found or device error
	{
		AfxMessageBox( "Device not found at 3BCh" );
		return;
	}
}


void CMainFrame::OnTestInit378() 
{
	// TODO: Add your command handler code here
	int iOK;

	AddMessage("\n");	// separate command output by line feed
	iOK = SetupDlk51(0x378); // generates initial values and setup file "dlk51.dat", search at port 378h
	if ( iOK != 0 )	// File or parallel port not found or device error
	{
		AfxMessageBox( "Device not found at 378h" );
		return;
	}
}


void CMainFrame::OnTestInit278() 
{
	// TODO: Add your command handler code here
	int iOK;
	
	AddMessage("\n");	// separate command output by line feed
	iOK = SetupDlk51(0x278); // generates initial values and setup file "dlk51.dat", search at port 278h
	if ( iOK != 0 )	// File or parallel port not found or device error
	{
		AfxMessageBox( "Device not found at 278h" );
		return;
	}
}


void CMainFrame::OnTestInitAux() 
{
	// TODO: Add your command handler code here
	int iOK;

	AddMessage("\n");	// separate command output by line feed
	iOK = SetupDlk51(0x1); // generates initial values and setup file "dlk51.dat", search at auxiliary port defined via setup file
	if ( iOK != 0 )	// File or parallel port not found or device error
	{
		AfxMessageBox( "Device not found at auxiliary port" );
		return;
	}
}


void CMainFrame::OnFILESaveMemory() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	FALSE,					// BOOL bOpenFileDialog, construct a File Save As dialog box
	"*.rom",					// LPCTSTR lpszDefExt = NULL
	"*.rom",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"ROM mirror file (*.rom)|*.rom||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL

	char szTitleOfFileOpenDlgBox[] = "Save flash memory user space";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail		
			FlashRead2File( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0, 0x7BFFF); // save all but init_data sector SA10
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashAll() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.rom",					// LPCTSTR lpszDefExt = NULL
	"*.rom",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"ROM mirror file (*.rom)|*.rom)||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL

	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Program flash memory user space ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			FlashSectorErase(FlashSA0); // erase sector SA0 - SA9
			FlashSectorErase(FlashSA1);
			FlashSectorErase(FlashSA2);
			FlashSectorErase(FlashSA3);
			FlashSectorErase(FlashSA4);
			FlashSectorErase(FlashSA5);
			FlashSectorErase(FlashSA6);
			FlashSectorErase(FlashSA7);
			FlashSectorErase(FlashSA8);
			FlashSectorErase(FlashSA9);
			FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0, 0x7BFFF, 0, 1, 0 ); // programm sector SA0 - SA9
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashCpuFile0() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bin",					// LPCTSTR lpszDefExt = NULL
	"*.bin",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"CPU program file (*.bin)|*.bin|MCS BASIC-52 file (*.b52)|*.b52||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL
	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space CPU file0 (default)";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Program flash memory user space CPU file0 (default) ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			if ( strcmp(strupr((LPSTR)(LPCTSTR)dlg.GetFileExt()),"BIN")) // compare file extension
			{
				// MCS BASIC-52 file
				BasicFlash( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0); // programm sector SA0
			}
			else 
			{
				// binary file
				m_iUpdateCPU=0; // copy filenumber for UpdateCPU command to global variable
				strcpy(m_szUpdateCPU,(LPSTR)(LPCTSTR)dlg.GetPathName()); // copy file- and pathname for UpdateCPU command to global variable
				FlashSectorErase(FlashSA0); // erase sector SA0
				FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0, 0xFFFF, 0, 1, 0 ); // programm sector SA0
			}
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashCpuFile1() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bin",					// LPCTSTR lpszDefExt = NULL
	"*.bin",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"CPU program file (*.bin)|*.bin|MCS BASIC-52 file (*.b52)|*.b52||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL
	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space CPU file1";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Program flash memory user space CPU file1 ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			if ( strcmp(strupr((LPSTR)(LPCTSTR)dlg.GetFileExt()),"BIN")) // compare file extension
			{
				// MCS BASIC-52 file
				BasicFlash( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x10000); // programm sector SA1
			}
			else 
			{
				// binary file
				m_iUpdateCPU=1; // copy filenumber for UpdateCPU command to global variable
				strcpy(m_szUpdateCPU,(LPSTR)(LPCTSTR)dlg.GetPathName()); // copy file- and pathname for UpdateCPU command to global variable
				FlashSectorErase(FlashSA1); // erase sector SA1
				FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x10000, 0x1FFFF, 0, 1, 0 ); // programm sector SA1
			}
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashCpuFile2() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bin",					// LPCTSTR lpszDefExt = NULL
	"*.bin",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"CPU program file (*.bin)|*.bin|MCS BASIC-52 file (*.b52)|*.b52||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL
	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space CPU file2";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Program flash memory user space CPU file2 ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			if ( strcmp(strupr((LPSTR)(LPCTSTR)dlg.GetFileExt()),"BIN")) // compare file extension
			{
				// MCS BASIC-52 file
				BasicFlash( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x20000); // programm sector SA2
			}
			else 
			{
				// binary file
				m_iUpdateCPU=2; // copy filenumber for UpdateCPU command to global variable
				strcpy(m_szUpdateCPU,(LPSTR)(LPCTSTR)dlg.GetPathName()); // copy file- and pathname for UpdateCPU command to global variable
				FlashSectorErase(FlashSA2); // erase sector SA2
				FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x20000, 0x2FFFF, 0, 1, 0 ); // programm sector SA2
			}
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashCpuFile3() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bin",					// LPCTSTR lpszDefExt = NULL
	"*.bin",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"CPU program file (*.bin)|*.bin|MCS BASIC-52 file (*.b52)|*.b52||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL
	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space CPU file3";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Program flash memory user space CPU file3 ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			if ( strcmp(strupr((LPSTR)(LPCTSTR)dlg.GetFileExt()),"BIN")) // compare file extension
			{
				// MCS BASIC-52 file
				BasicFlash( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x30000); // programm sector SA3
			}
			else 
			{
				// binary file
				m_iUpdateCPU=3; // copy filenumber for UpdateCPU command to global variable
				strcpy(m_szUpdateCPU,(LPSTR)(LPCTSTR)dlg.GetPathName()); // copy file- and pathname for UpdateCPU command to global variable
				FlashSectorErase(FlashSA3); // erase sector SA3
				FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x30000, 0x3FFFF, 0, 1, 0 ); // programm sector SA3
			}
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashFpgaFile0() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bit",					// LPCTSTR lpszDefExt = NULL
	"*.bit",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"FPGA config file (*.bit)|*.bit)||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL

	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space FPGA file0 (default)";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed	
		AddMessage("Program flash memory user space FPGA file0 (default) ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			FlashSectorErase(FlashSA4); // erase sector SA4 - SA5
			FlashSectorErase(FlashSA5);
			FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x40000, 0x5FFFF, 0, 1, 1 ); // programm sector SA4 - SA5
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFileProgramFlashFpgaFile1() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bit",					// LPCTSTR lpszDefExt = NULL
	"*.bit",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"FPGA config file (*.bit)|*.bit)||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL

	char szTitleOfFileOpenDlgBox[] = "Program flash memory user space FPGA file1";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Program flash memory user space FPGA file1 ...\n");	// message
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			FlashSectorErase(FlashSA6); // erase sector SA6 - SA7
			FlashSectorErase(FlashSA7);
			FlashProgram( (LPSTR)(LPCTSTR)dlg.GetPathName(), 0x60000, 0x77FFF, 0, 1, 1 ); // programm sector SA6 - SA7
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
		}
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFpgaConfigPc() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.bit",					// LPCTSTR lpszDefExt = NULL
	"*.bit",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"FPGA config file (*.bit)|*.bit)||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL

	char szTitleOfFileOpenDlgBox[] = "Config FPGA via PC";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		FpgaConfig( ( (LPSTR)(LPCTSTR)dlg.GetPathName() ),1,1); // Fpga konfigurieren, Fullpath, refresh run
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnFpgaConfigFlash() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	FpgaConfig(FpgaFlash,0, 1); // configure Fpga via Flash memory, no path, PPFpgaRun
}


void CMainFrame::OnFpgaClear() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	FpgaConfig(FpgaClear,0, 1); // clear FPGA configuration, no path, PPFpgaRun
}


void CMainFrame::OnCommandCpuDisable() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	CpuReset(1); // CPU reset, stay in reset
}


void CMainFrame::OnCpuRunfile0() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	CpuRunFile(0); // run CPU programm file0
}


void CMainFrame::OnCpuRunfile1() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	CpuRunFile(1); // run CPU programm file1
}


void CMainFrame::OnCpuRunfile2() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	CpuRunFile(2); // run CPU programm file2
}


void CMainFrame::OnCpuRunfile3() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	CpuRunFile(3); // run CPU programm file3
}


void CMainFrame::OnFILEEraseFlashFpgaFILE0() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA4); // erase sector SA4
		FlashSectorErase(FlashSA5); // erase sector SA5
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnFILEEraseFlashFpgaFILE1() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA6); // erase sector SA6
		FlashSectorErase(FlashSA7); // erase sector SA7
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnFILEEraseFlashCPUFILE0() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA0); // erase sector SA0
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnFILEEraseFlashCPUFILE1() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA1); // erase sector SA1
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnFILEEraseFlashCPUFILE2() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA2); // erase sector SA2
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnFILEEraseFlashCPUFILE3() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA3); // erase sector SA3
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnFILEEraseFlashAll() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		FlashSectorErase(FlashSA0); // erase sector SA0 - SA7
		FlashSectorErase(FlashSA1);
		FlashSectorErase(FlashSA2);
		FlashSectorErase(FlashSA3);
		FlashSectorErase(FlashSA4);
		FlashSectorErase(FlashSA5);
		FlashSectorErase(FlashSA6);
		FlashSectorErase(FlashSA7);
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnCOMMANDCOMMANDTestFpgaIo() 
{
	// TODO: Add your command handler code here
	CString s;
	int iErr=0;
	
	AddMessage("\n");	// separate command output by line feed
	AddMessage("Test FPGA I/Os ...\n");	// message
	AddMessage("for testability following pins at dlk51, X2 have to be connected via a 1K resistor:\n");	
	AddMessage("2B   3B   4B   5B   6B   7B    8B    10B   10A   11B   12B   13B   14B   15B   16B   22B\n");
	AddMessage("LIO0 LIO2 LIO4 LIO6 LIO8 LIO10 LIO12 LIO14 LIO15 LIO16 LIO18 LIO20 LIO22 LIO24 LIO26 LIO28\n");
	AddMessage("|    |    |    |    |    |     |     |     |     |     |     |     |     |     |     | \n");
	AddMessage("LIO1 LIO3 LIO5 LIO7 LIO9 LIO11 LIO13 LI0   LI1   LIO17 LIO19 LIO21 LIO23 LIO25 LIO27 LIO29\n");
	AddMessage("2A   3A   4A   5A   6A   7A    8A    9B    9A    11A   12A   13A   14A   15A   16A   13B\n");
	AddMessage("Input function at X2 pin LIO14,10B and LIO15,10A will not be tested\n");
	FpgaConfig("LIOTESTA.BIT",0, 0);
	s = "Test connections have to be installed\n\n\nDoes LED 'TEST' flash fast ?";
	if (AfxMessageBox(s, MB_ICONQUESTION | MB_YESNO ) != IDNO)
	{
		FpgaConfig("LIOTESTB.BIT",0, 0);
		s = "Test connections have to be installed\n\n\nDoes LED 'TEST' flash slow ?";
		if (AfxMessageBox(s, MB_ICONQUESTION | MB_YESNO ) != IDNO)
			iErr=0;
		else
			iErr=1;
	}	
	else
		iErr=1;
	if (iErr != 0)
	{
		AfxMessageBox("ERROR: Check FPGA I/Os", MB_ICONEXCLAMATION  | MB_OK );
		AddMessage("-> ERROR: FPGA I/O test failed\n"); // message
	}
	else
		AddMessage("-> FPGA I/O test OK\n"); // message
	FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
}


void CMainFrame::OnCOMMANDTestElabBaseIo() 
{
	// TODO: Add your command handler code here
	CString s;
	int iErr=0;
	
	AddMessage("\n");	// separate command output by line feed
	AddMessage("Test eLABbase I/Os ...\n");	// message
	AddMessage("for testability following pins at eLABbase, X1 and X2 have to be connected via a 1K resistor:\n");	
	AddMessage("P1   P5  P2   P6   P9   P13   P10   P14   P17   P21   P18   P22   P25   P29   P26   P30\n");
	AddMessage("|    |    |    |    |    |     |     |     |     |     |     |     |     |     |     | \n");
	AddMessage("P3   P7  P4   P8   P11  P15   P12   P16   P19   P23   P20   P24   P27   P31   P28   P32\n");
	AddMessage("Input function at X2, P29 and P30 will not be tested\n");
	FpgaConfig("eLABbaseTestA.BIT",0, 0);
	s = "Test connections have to be installed\n\n\nDoes LED 'TEST' flash fast ?";
	if (AfxMessageBox(s, MB_ICONQUESTION | MB_YESNO ) != IDNO)
	{
		FpgaConfig("eLABbaseTestB.BIT",0, 0);
		s = "Test connections have to be installed\n\n\nDoes LED 'TEST' flash slow ?";
		if (AfxMessageBox(s, MB_ICONQUESTION | MB_YESNO ) != IDNO)
			iErr=0;
		else
			iErr=1;
	}	
	else
		iErr=1;
	if (iErr != 0)
	{
		AfxMessageBox("ERROR: Check eLABbase I/Os", MB_ICONEXCLAMATION  | MB_OK );
		AddMessage("-> ERROR: eLABbase I/O test failed\n"); // message
	}
	else
		AddMessage("-> eLABbase I/O test OK\n"); // message
	FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
}


void CMainFrame::OnCOMMANDCOMMANDSaveBasic() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(
	TRUE,						// BOOL bOpenFileDialog, construct a File Open dialog box 
	"*.b52",					// LPCTSTR lpszDefExt = NULL
	"*.b52",					// LPCTSTR lpszFileName = NULL
	OFN_EXPLORER|OFN_HIDEREADONLY,			// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
	"MCS BASIC-52 program (*.b52)|*.b52||",	// LPCTSTR lpszFilter = NULL
	GetParent() );			// CWnd* pParentWnd = NULL

	char szTitleOfFileOpenDlgBox[] = "Save MCS BASIC-52 program from RAM to disk";
	dlg.m_ofn.lpstrTitle = szTitleOfFileOpenDlgBox;

	// DDX
	if ( IDOK == dlg.DoModal() ) // OK pressed
	{
		AddMessage("\n");	// separate command output by line feed
		AddMessage("Device has to be configured for MCS BASIC-52\n");	// message
		Basic2File( ( (LPSTR)(LPCTSTR)dlg.GetPathName() ), 4096); // Save MCS BASIC-52 program to disk, SRAMsize 4096 byte
	}
	else // Esc pressed
	{
		// do nothing
	}
}


void CMainFrame::OnCommandEmuAT89ispCable() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	AddMessage("Emulate ATMEL AT89isp cable ...\n");// message
	AddMessage("Compatible to AT89isp software\n");	
	AddMessage("ISP signal:        RST  MOSI MISO SCK\n");
	AddMessage("dlk51, X2:         4b   4a   5b   5a\n");
	AddMessage("eLABbase port, X1: P5   P6   P7   P8\n");	
	FpgaConfig(FpgaAT89isp,0, 0); // config ATMEL AT89isp cable emulation, filename without path, do not update PPFpgaRun
	AfxMessageBox("Emulation mode active:\nATMEL AT89isp cable\n\n-> ready for 'In-System Programming' now\n\n Press OK to leave emulation mode", MB_ICONINFORMATION | MB_OK );
	FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
}


void CMainFrame::OnCommandEmuAVRispDongle() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	AddMessage("Emulate ATMEL AVR ISP dongle ...\n");// message
	AddMessage("Compatible to STK200 / STK300\n");	
	AddMessage("ISP signal:        RST  MOSI MISO SCK\n");
	AddMessage("dlk51, X2:         4b   4a   5b   5a\n");
	AddMessage("eLABbase port, X1: P5   P6   P7   P8\n");	
	FpgaConfig(FpgaAVRDef,0, 0); // config ATMEL AVR ISP dongle emulation, filename without path, do not update PPFpgaRun
	AfxMessageBox("Emulation mode active:\nATMEL AVR ISP dongle\n\n-> ready for 'In-System Programming' now\n\n Press OK to leave emulation mode", MB_ICONINFORMATION | MB_OK );
	FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
}


void CMainFrame::OnCOMMANDCOMMANDEmuDlc5() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	AddMessage("Emulate XILINX JTAG download cable ...\n");// message
	AddMessage("Compatible to DLC5 / Parallel Cable III\n");	
	AddMessage("JTAG signal:       TCK  TMS  TDO  TDI\n");
	AddMessage("dlk51, X2:         4b   4a   5b   5a\n");
	AddMessage("eLABbase port, X1: P5   P6   P7   P8\n");	
	FpgaConfig(FpgaEmuDef,0, 0); // config Xilinx DLC5 emulation, filename without path, do not update PPFpgaRun
	AfxMessageBox("Emulation mode active:\nXILINX DLC5 / Parallel Cable III\n\n-> ready for 'iMPACT' now\n\n Press OK to leave emulation mode", MB_ICONINFORMATION | MB_OK );
	FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
}


void CMainFrame::OnCOMMANDCOMMANDTransferRate() 
{
	// TODO: Add your command handler code here
	int iRate;
	char szText[100];

	AddMessage("\n");	// separate command output by line feed
	AddMessage("Check transfer rates\n");
	if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
	{ 
		// NO ERROR, FPGA CheckDeviceConnected did not fail
		iRate=GetTransferRate(2, RegRomData, RegRomCtrl, 100);
		sprintf( szText, "PC -> mm-bus: %ld Kbyte/sec, streaming\n", iRate );
		AddMessage( szText );
		iRate=GetTransferRate(0, RegRomData, RegRomCtrl, 100);
		sprintf( szText, "PC -> mm-bus: %ld Kbyte/sec\n", iRate );
		AddMessage( szText );
		iRate=GetTransferRate(3, RegRomData, RegRomCtrl, 100);
		sprintf( szText, "PC <- mm-bus: %ld Kbyte/sec, streaming\n", iRate );
		AddMessage( szText );
		iRate=GetTransferRate(1, RegRomData, RegRomCtrl, 100);
		sprintf( szText, "PC <- mm-bus: %ld Kbyte/sec\n", iRate );
		AddMessage( szText );
		FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
	}
}


void CMainFrame::OnUpdateCPU() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	if (strcmp(m_szUpdateCPU," ") != 0) // compare with pre-init value
	{
		if (FpgaCfgForSetup(1,0)==0) // Fpga config for setup, if necessary
		{ 
			// NO ERROR, FPGA CheckDeviceConnected did not fail
			switch( m_iUpdateCPU ) 
			{
				case 3:
					AddMessage("Program flash memory user space CPU file3 ...\n");	// message
					FlashSectorErase(FlashSA3); // erase sector SA3
					FlashProgram( m_szUpdateCPU, 0x30000, 0x3FFFF, 0, 1, 0 ); // programm sector SA3
					break;
				case 2:
					AddMessage("Program flash memory user space CPU file2 ...\n");	// message
					FlashSectorErase(FlashSA2); // erase sector SA2
					FlashProgram( m_szUpdateCPU, 0x20000, 0x2FFFF, 0, 1, 0 ); // programm sector SA2
					break;
				case 1:
					AddMessage("Program flash memory user space CPU file1 ...\n");	// message
					FlashSectorErase(FlashSA1); // erase sector SA1
					FlashProgram( m_szUpdateCPU, 0x10000, 0x1FFFF, 0, 1, 0 ); // programm sector SA1
					break;
				default:
					AddMessage("Program flash memory user space CPU file0 (default) ...\n");	// message
					FlashSectorErase(FlashSA0); // erase sector SA0
					FlashProgram( m_szUpdateCPU, 0, 0xFFFF, 0, 1, 0 ); // programm sector SA0, binary file
			}
			FpgaCfgForSetup(0,0); // Fpga config to run configuration, if necessary
			CpuRunFile(m_iUpdateCPU); // run last flashed CPU programm
		}
	}
	else
		AddMessage("ERROR: cant repeat command, first use 'File - Program flash - CPU fileX ...'\n");
}


void CMainFrame::OnUpdateFPGA() 
{
	// TODO: Add your command handler code here
	AddMessage("\n");	// separate command output by line feed
	FpgaCfgForSetup(0,1); // Fpga config to run configuration, must
	if (strcmp(m_szUpdateCPU," ") != 0) // compare with pre-init value
		CpuRunFile(m_iUpdateCPU); // run last flashed CPU programm if program-file already manually selected
}


