/*************************************************
**	Copyright (C) 2002 SENG digitale Syteme GmbH
**
**	SENG digitale Systeme GmbH
**	Im Bruckwasen 35
**	D 73037 Goeppingen
**	Germany
**	http://www.seng.de
*************************************************/



//  ProgressDlg.cpp : Implementierungsdatei
// CG: Diese Datei wurde von der Komponente "Dialogfeld Fortschritt" hinzugefgt

#include "stdafx.h"
#include "resource.h"
#include "ProgressDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgressDlg Dialogfeld

CProgressDlg::CProgressDlg(UINT nCaptionID)
{
	m_nCaptionID = CG_IDS_PROGRESS_CAPTION;
	if (nCaptionID != 0)
		m_nCaptionID = nCaptionID;

    m_bCancel=FALSE;
    m_nLower=0;
    m_nUpper=20;
    m_nStep=1;
    //{{AFX_DATA_INIT(CProgressDlg)
    // HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
    //}}AFX_DATA_INIT
    m_bParentDisabled = FALSE;
}

CProgressDlg::~CProgressDlg()
{
    if(m_hWnd!=NULL)
      DestroyWindow();
}

BOOL CProgressDlg::DestroyWindow()
{
    ReEnableParent();
    return CDialog::DestroyWindow();
}

void CProgressDlg::ReEnableParent()
{
    if(m_bParentDisabled && (m_pParentWnd!=NULL))
      m_pParentWnd->EnableWindow(TRUE);
    m_bParentDisabled=FALSE;
}

BOOL CProgressDlg::Create(CWnd *pParent)
{
    // Tatschliches bergeordnetes Element des Dialogfelds bereitstellen
    m_pParentWnd = CWnd::GetSafeOwner(pParent);

    // m_bParentDisabled dient dem Neuaufbau des bergeordneten Fensters,
    // wenn das Dialogfeld entfernt wurde. Deshalb sollte sie nicht auf TRUE 
    // gesetzt werden, es sei denn das bergeordnete Fenster war bereits aktiviert.

    if((m_pParentWnd!=NULL) && m_pParentWnd->IsWindowEnabled())
    {
      m_pParentWnd->EnableWindow(FALSE);
      m_bParentDisabled = TRUE;
    }

    if(!CDialog::Create(CProgressDlg::IDD,pParent))
    {
      ReEnableParent();
      return FALSE;
    }

    return TRUE;
}

void CProgressDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CProgressDlg)
    DDX_Control(pDX, CG_IDC_PROGDLG_PROGRESS, m_Progress);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProgressDlg, CDialog)
    //{{AFX_MSG_MAP(CProgressDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CProgressDlg::OnCancel()
{
    m_bCancel=TRUE;
}

void CProgressDlg::SetRange(int nLower,int nUpper)
{
    m_nLower = nLower;
    m_nUpper = nUpper;
    m_Progress.SetRange(nLower,nUpper);
}
  
int CProgressDlg::SetPos(int nPos)
{
    PumpMessages();
    int iResult = m_Progress.SetPos(nPos);
    //UpdatePercent(nPos);		// keine Prozentausgabe
    return iResult;
}

int CProgressDlg::SetStep(int nStep)
{
    m_nStep = nStep; // Fr sptere Prozentberechnung speichern
    return m_Progress.SetStep(nStep);
}

int CProgressDlg::OffsetPos(int nPos)
{
    PumpMessages();
    int iResult = m_Progress.OffsetPos(nPos);
    //UpdatePercent(iResult+nPos);
    return iResult;
}

int CProgressDlg::StepIt()
{
    PumpMessages();
    int iResult = m_Progress.StepIt();
    //UpdatePercent(iResult+m_nStep);
    return iResult;
}

void CProgressDlg::PumpMessages()
{
    // Muss Create() aufrufen, bevor das Dialogfeld verwendet wird
    ASSERT(m_hWnd!=NULL);

    MSG msg;
    // Verarbeiten von Dialogfeld-Nachrichten
    while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
      if(!IsDialogMessage(&msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);  
      }
    }
}

BOOL CProgressDlg::CheckCancelButton()
{
    // Anstehende Nachrichten verarbeiten
    PumpMessages();

    // Setzen Sie  m_bCancel auf FALSE zurck, damit 
    // CheckCancelButton FALSE zurckgibt, bis der Benutzer
    // erneut auf "Abbrechen" klickt. Dies ermglicht den Aufruf von CheckCancelButton
    // aufgerufen werden, und gleichzeitig kann die Operation noch fortgesetzt werden.
    // Behlt m_bCancel den Wert TRUE, dann gibt der nchste Aufruf von
    // CheckCancelButton immer TRUE zurck

    BOOL bResult = m_bCancel;
    m_bCancel = FALSE;

    return bResult;
}

void CProgressDlg::UpdatePercent(int nNewPos)
{
    CWnd *pWndPercent = GetDlgItem(CG_IDC_PROGDLG_PERCENT);
    int nPercent;
    
    int nDivisor = m_nUpper - m_nLower;
    ASSERT(nDivisor>0);  // m_nLower sollte kleiner als m_nUpper sein

    int nDividend = (nNewPos - m_nLower);
    ASSERT(nDividend>=0);   // Die aktuelle Position sollte grer als m_nLower sein

    nPercent = nDividend * 100 / nDivisor;

    // Da die Statusanzeige umbricht, mssen die Prozente auch mit 
    // umgebrochen werden. Setzen Sie aber nicht 100% auf 0% zurck
    if(nPercent!=100)
      nPercent %= 100;

    // Prozentsatz anzeigen
    CString strBuf;
    strBuf.Format(_T("%d%c"),nPercent,_T('%'));

	CString strCur; // Aktuellen Prozentsatz bereitstellen
    pWndPercent->GetWindowText(strCur);

	if (strCur != strBuf)
		pWndPercent->SetWindowText(strBuf);
}
    
/////////////////////////////////////////////////////////////////////////////
// CProgressDlg -Behandlungsroutinen

BOOL CProgressDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();
    m_Progress.SetRange(m_nLower,m_nUpper);
    m_Progress.SetStep(m_nStep);
    m_Progress.SetPos(m_nLower);

	CString strCaption;
	VERIFY(strCaption.LoadString(m_nCaptionID));
    SetWindowText(strCaption);

    return TRUE;  
}
