/*************************************************
**	Copyright (C) 2002 SENG digitale Syteme GmbH
**
**	SENG digitale Systeme GmbH
**	Im Bruckwasen 35
**	D 73037 Goeppingen
**	Germany
**	http://www.seng.de
*************************************************/



// SetupDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "dlk51.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CSetupDlg 


CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_fRefVoltage = 0.0f;
	m_iIolptIdx = 0;
	m_bRButtonRefVoltage = TRUE;
	//}}AFX_DATA_INIT
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Control(pDX, IDC_CHECK_REFVOLTAGE, m_RefVoltageCButtonCtrl);
	DDX_Control(pDX, IDC_EDIT_REFVOLTAGE, m_RefVoltageEditCtrl);
	DDX_Text(pDX, IDC_EDIT_REFVOLTAGE, m_fRefVoltage);
	DDX_Radio(pDX, IDC_RADIO1, m_iIolptIdx);
	DDX_Check(pDX, IDC_CHECK_REFVOLTAGE, m_bRButtonRefVoltage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_BN_CLICKED(IDC_CHECK_REFVOLTAGE, OnCheckRefvoltage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSetupDlg 

void CSetupDlg::OnOK() 
{
	// TODO: Zustzliche Prfung hier einfgen

	// DDX: get values from controls
	BOOL bSaveAndValidate = TRUE;
	UpdateData( bSaveAndValidate );

	if ( m_bRButtonRefVoltage )
	{
		// Check Range of RefVoltage
		CString strRefVoltage;
		m_RefVoltageEditCtrl.GetWindowText( strRefVoltage );
		float fRefVoltage = (float)atof( strRefVoltage );
		if ( fRefVoltage < 8.9f || fRefVoltage > 9.3f )
		{
			// Fehler: Auerhalb range
			AfxMessageBox( "RefVoltage:\n\nInput out of valid range\nplease correct input");
			m_RefVoltageEditCtrl.SetFocus();
			return;	// nix OK 
		}

	}
	
	CDialog::OnOK();
}

void CSetupDlg::OnCheckRefvoltage() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	int iCheckState = m_RefVoltageCButtonCtrl.GetCheck();
	if ( iCheckState == 1 )
	{
		// Checked --> Enable RefVoltage Editfield
		m_RefVoltageEditCtrl.EnableWindow( TRUE );
	}
	else
	{
		// Unchecked --> Disable RefVoltage Editfield
		m_RefVoltageEditCtrl.EnableWindow( FALSE );
	}
	
}
