/*************************************************
**	Copyright (C) 2002 SENG digitale Syteme GmbH
**
**	SENG digitale Systeme GmbH
**	Im Bruckwasen 35
**	D 73037 Goeppingen
**	Germany
**	http://www.seng.de
*************************************************/



// TestDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"

#include "dlk51_dll_Export.h"

#include "dlk51.h"
#include "MainFrm.h"
#include "TestDlg.h"
#include "ProgressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CTestDlg 


CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
	//}}AFX_DATA_INIT

	m_pMainFrame = NULL;
}


void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_EDIT_CMDLINE, m_CmdLineEditCtrl);
	DDX_Control(pDX, IDC_BUTTON_CMDLINE, m_CmdLineButtonCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_EN_CHANGE(IDC_EDIT_CMDLINE, OnChangeEditCmdLine)
	ON_BN_CLICKED(IDC_BUTTON_CMDLINE, OnButtonCmdline)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CTestDlg 

void CTestDlg::OnChangeEditCmdLine() 
{
	// TODO: Wenn es sich hierbei um ein RICHEDIT-Steuerelement handelt, sendet es
	// sendet diese Benachrichtigung nur, wenn die Funktion CDialog::OnInitDialog()
	// berschrieben wird, um die EM_SETEVENTMASK-Nachricht an das Steuerelement
	// mit dem ENM_CHANGE-Attribut ORed in die Maske lParam zu senden.
	
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	
	// Enable Button "CmdLine ausfhren"
	m_CmdLineButtonCtrl.EnableWindow(TRUE);
	
}

BOOL CTestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Zustzliche Initialisierung hier einfgen

	// Disable Button "CmdLine ausfhren"
	m_CmdLineButtonCtrl.EnableWindow(FALSE);

	// Eingabefokus auf CmdLine-Editfeld setzen
	m_CmdLineEditCtrl.SetFocus();


	/*
	m_pMainFrame->AddMessage("\n");
	m_pMainFrame->AddMessage("TestFunktionen\n");
	*/
	
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}


void CTestDlg::ExecuteCmdLine(char * pszCmdLine)
{
	char			cCommand, szFile[20];
	char			szTemp[256];
	int			iA/*, iB*/;
	UINT			uA, uB/*, uC*/;

	// Progress Dialog
	CProgressDlg dlg;

	// 1. char == command
	strupr(pszCmdLine);						// convert CmdLine (input-command) to uppercase 
	sscanf(pszCmdLine,"%c",&cCommand);	// get command (1. character) from string
	pszCmdLine=pszCmdLine+2;				// delete command from string

	// 2. interprete string, without any check !
	switch (cCommand)
	{ 
		case 'O':
			sscanf(pszCmdLine, "%x%x", &uA, &uB);
			outbyte(uA, uB); // write data and address to mm-bus
			sprintf( szTemp, "%.2Xh written to address %.2Xh\n", uB, uA );
			m_pMainFrame->AddMessage(szTemp);
			break;

		case 'I':
			sscanf(pszCmdLine, "%x", &uA);
			uB = inbyte(uA); // read data from address at mm-bus
			sprintf( szTemp, "%.2Xh read from address %.2Xh\n", uB, uA );
			m_pMainFrame->AddMessage(szTemp);
			break;

		case 'S':
			sscanf(pszCmdLine, "%x", &uA);
			PPinitSet(uA); // set/reset PC parallel port control signal PPinit
			if (uA!=0)
				sprintf(szTemp,"Signal PPinit set, now at high level, default setting\n");
			else
				sprintf(szTemp,"Signal PPinit reset, now at low level\n");
			m_pMainFrame->AddMessage(szTemp);
			break;

		case 'G':
			uA=PPackGet(); // read status of PC parallel port (interrupt) input signal PPack
			if (uA!=0)
				sprintf(szTemp,"Signal PPack is at high level, enabled\n");			
			else
				sprintf(szTemp,"Signal PPack is at low level, disabled\n");
			m_pMainFrame->AddMessage(szTemp);
			break;

		case 'C': // configures Spartan2 FPGA at PC parallel printer port
			sscanf(pszCmdLine,"%s",&szFile);
			FpgaConfig(szFile,1,1); // Fpga konfigurieren, Fullpath, refresh run
			break;

		case 'F': // program bytewide MBM29LV400TC flash memory
			/*sscanf(pszCmdLine, "%s %lx %lx %lx %x %x" , &szFile, &uA, &uB, &uC, &iA, &iB);
			FlashProgram( szFile, uA, uB, uC, iA, iB );*/
			break;

		case '@': // JUST FOR DEMO
			iA = 1;			
			dlg.Create();
			while (1) // endless loop		
			{
				// add command here
				m_pMainFrame->AddMessage("nothing happens, just waiting\n");

			
				// end command here
				if ( dlg.CheckCancelButton() ) // check cancel button
				{
					m_pMainFrame->AddMessage("aborted\n");
					break; // exit endless loop, user pressed "cancel" button
				}
				Sleep(100);	// wait 100 msec
				if ( (iA % 10) == 0 ) // increment status bar
					dlg.StepIt(); // step bar every 1 sec = 10 * 100 msec
				iA++;		// Inkr LoopCounter
			}
			break;

		case '?': // Help
			m_pMainFrame->HelpScreen();
			break;

		default:
			MessageBeep(MB_ICONASTERISK);
			m_pMainFrame->AddMessage("Sorry, this command is not implemented\n");
			break;
	} // of switch

	// add new line between commands
	m_pMainFrame->AddMessage("\n");
} 


void CTestDlg::OnButtonCmdline() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	// get Text of CmdLine --> szCmdLine
	char szCmdLine[256];
	m_CmdLineEditCtrl.GetWindowText( szCmdLine, 255 );

	// Ausgabe CmdLine im Protokoll
	m_pMainFrame->AddMessage(szCmdLine);
	m_pMainFrame->AddMessage("\n");

	
	// Execute Cmd from CmdLine
	ExecuteCmdLine( szCmdLine );

	// CmdLine lschen
	m_CmdLineEditCtrl.SetWindowText("");

}

void CTestDlg::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if ( nChar == VK_ESCAPE )
		PostMessage( WM_COMMAND, IDOK);
	
	CDialog::OnChar(nChar, nRepCnt, nFlags);
}
